#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include "mpi_tools.h"

void distributing_row(void)
 {
  //distrib of row for each proc
  int divi, reste, j;
  width_info = (int*) calloc(comm_size + 1, sizeof(int));
  divi = (int) (WIDTH/comm_size);
  reste = WIDTH % comm_size;
  width_info[0]=0;
  
  for(j=1; j<comm_size+1; j++)
    {
      width_info[j]= width_info[j-1]+ divi;
      if (j-1 < reste) width_info[j] += 1;
    }

  my_width = width_info[my_rank+1] - width_info[my_rank];
  debug(" my_width_info : %d ", my_width); 
}

/* here your have to write the function that gathers 
 * the partial results from every process to the process with rank 0. 
 */
void rebuild_solution (struct cell *global_current_cellulae, struct cell *current_cellulae, int my_width){ 






}

/* here you create a new MPI data type named MPI_CELLULAE
 * containing 4 elements :
 * - one MPI_CHAR
 * - three MPI_INT
 * and a second one named MPI_ANT_TRANSFERT
 * containing 2 MPI_UNSIGNED elements.
 */
void create_data_struct_mpi(void){
 



}

void init_bound_value(void){
  int i;
  //debug("init to zero ants_from.... ants_to..."); 
  if(!westest_rank) {
    for (i=0; i<HEIGHT; i++) {
      ants_from_west[i].ant_loaded = 0;
      ants_from_west[i].ant_seeking = 0;;
      ants_to_west[i].ant_loaded = 0;
      ants_to_west[i].ant_seeking = 0;;
    }
  }
  
  if(!eastest_rank) {
    for (i=0; i<HEIGHT; i++) {
      ants_from_east[i].ant_loaded = 0;
      ants_from_east[i].ant_seeking = 0;
      ants_to_east[i].ant_loaded = 0;
      ants_to_east[i].ant_seeking = 0;
    }
  }
}

void update_bound_celllulae(void)
{
  int i, dec;
  
  if(!westest_rank){
    //debug("update ant info from WEST COAST");
    for (i=0; i<HEIGHT; i++) {
      if (ants_from_west[i].ant_loaded != 0){
	ants_by_process += ants_from_west[i].ant_loaded;
	debug("ants_by_process = %d",ants_by_process);
	current_cellulae[i].ant_loaded += ants_from_west[i].ant_loaded;
      }
      if (ants_from_west[i].ant_seeking != 0){
	ants_by_process += ants_from_west[i].ant_seeking;
	debug("ants_by_process = %d",ants_by_process);
	current_cellulae[i].ant_seeking += ants_from_west[i].ant_seeking;
      }
    }
  }
  
  if(!eastest_rank){
    dec = (my_width-1) * HEIGHT;
    //debug("update ant info from EAST COAST my_width = %d dec = %d", my_width, dec);
    for (i=0; i<HEIGHT; i++) {
      if (ants_from_east[i].ant_loaded != 0){
	ants_by_process += ants_from_east[i].ant_loaded;
	debug("ants_by_process = %d",ants_by_process);
	current_cellulae[i+dec].ant_loaded += ants_from_east[i].ant_loaded;
      }
      if(ants_from_east[i].ant_seeking){
	ants_by_process += ants_from_east[i].ant_seeking;
	debug("ants_by_process = %d",ants_by_process);
	current_cellulae[i+dec].ant_seeking += ants_from_east[i].ant_seeking;
      }
    }
  }
}



void create_comm_tore_1D(void){
  
  int mpierrno;
  int dim, period, reorder;
  
  dim = comm_size;
  period = 0;
  reorder = 0;
  
  mpierrno = MPI_Cart_create(MPI_COMM_WORLD , 1, &dim, &period, reorder, &comm_tore_1D);
  MPI_Cart_shift(comm_tore_1D, 0, 1, &my_west_rank, &my_east_rank);
  debug("my_rank = %d  my_west_rank = %d  my_east_rank = %d", my_rank, my_west_rank, my_east_rank);
} 
